package classicguns;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.Item;
import net.minecraftforge.fml.loading.FMLLoader;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegisterEvent;
import net.minecraftforge.registries.RegistryObject;

public class AddGuns {
    public static void registerItem(RegisterEvent event) {
        mod_ClassicGuns mod = mod_ClassicGuns.INSTANCE;
        event.register(ForgeRegistries.Keys.ITEMS,
                helper -> {
                    {
                        mod.item_hg = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_hg"), ForgeRegistries.ITEMS);
                        helper.register(new ResourceLocation(mod.MOD_ID,"item_hg"),
                                new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(7)).LoadingEvent("item_hg.txt"));
                    }
                    {
                        mod.item_smg = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_smg"), ForgeRegistries.ITEMS);
                        helper.register(new ResourceLocation(mod.MOD_ID,"item_smg"),
                                new ItemGun_AR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(21)).LoadingEvent("item_smg.txt"));
                    }
                    {
                        mod.item_sr = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_sr"), ForgeRegistries.ITEMS);
                        helper.register(new ResourceLocation(mod.MOD_ID,"item_sr"),
                                new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(2)).LoadingEvent("item_sr.txt"));
                    }
                    {
                        mod.item_sg = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_sg"), ForgeRegistries.ITEMS);
                        helper.register(new ResourceLocation(mod.MOD_ID,"item_sg"),
                                new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(4)).LoadingEvent("item_sg.txt"));
                    }
                    {
                        mod.item_mg = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_mg"), ForgeRegistries.ITEMS);
                        helper.register(new ResourceLocation(mod.MOD_ID,"item_mg"),
                                new ItemGun_AR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(65)).LoadingEvent("item_mg.txt"));
                    }
                    {
                        mod.item_gl = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_gl"), ForgeRegistries.ITEMS);
                        helper.register(new ResourceLocation(mod.MOD_ID,"item_gl"),
                                new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(2)).LoadingEvent("item_gl.txt"));
                    }
                    {
                        mod.item_flare = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_flare"), ForgeRegistries.ITEMS);
                        helper.register(new ResourceLocation(mod.MOD_ID,"item_flare"),
                                new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(2)).LoadingEvent("item_flare.txt"));
                    }
                }
        );
    }
}
