package classicguns;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.Items;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.fml.loading.FMLLoader;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegisterEvent;
import net.minecraftforge.registries.RegistryObject;

public class AddItems {
    public static final DeferredRegister<Item> ITEMS =
            DeferredRegister.create(ForgeRegistries.ITEMS, mod_ClassicGuns.MOD_ID);
    /*public static final RegistryObject<Item> item_bullet = ITEMS.register("item_bullet",
            () -> new Item(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT)));

    public static final RegistryObject<Item> item_smg = ITEMS.register("item_smg",
            () -> new ItemGun_AR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT)));*/

    public static void registerItem(RegisterEvent event) {
        mod_ClassicGuns mod = mod_ClassicGuns.INSTANCE;
        {
            mod.item_bullet = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_bullet"), ForgeRegistries.ITEMS);
            mod.item_grenade = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_grenade"), ForgeRegistries.ITEMS);
            /*{
                ItemGunBase gun = (ItemGunBase) mod.item_hg.get();
                if (FMLLoader.getDist().isClient())
                {
                    gun.obj_true = true;
                    gun.obj_model_resource = "classicguns:textures/model/model_hg.mqo";
                    gun.obj_tex = "classicguns:textures/model/model_hg.png";
                }
                gun.powor = 5;
                gun.speed = 3F;
                gun.bure = 3F;
                gun.bureads = 1.0F;
                gun.recoil = 2.0F;
                gun.recoilads = 0.5F;
                gun.reloadtime = 40;
                gun.scopezoom = 1.0F;
                gun.cycle = 3;

                gun.magazine = mod.item_bullet.get();
                gun.fire_sound = "fire_hg";

                gun.model_y = -1.5F;
                gun.Sprintrotationx = -60F;
                gun.Sprintrotationy = 00F;
                gun.Sprintrotationz = 0F;
                gun.model_x_ads = 0.0F;
                gun.model_y_ads = -1.23F;
                gun.model_z_ads = -1.5F;
                gun.model_muzz_jump_x = -5;
                gun.model_cock_z = -0.4F;
            }*/
            event.register(ForgeRegistries.Keys.ITEMS,
                    helper -> {
                        helper.register(new ResourceLocation(mod.MOD_ID,"item_bullet"),
                                new Item(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT)));

                        helper.register(new ResourceLocation(mod.MOD_ID,"item_grenade"),
                                new ItemGrenade(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).stacksTo(8)));
                    }
            );
        }


    }


    public static void register(IEventBus eventBus) {
        ITEMS.register(eventBus);
        mod_ClassicGuns mod = mod_ClassicGuns.INSTANCE;
       /* {
            mod.item_bullet = RegistryObject.create(new ResourceLocation(mod.MOD_ID,"item_bullet"), ForgeRegistries.ITEMS);
            mod.item_bullet =  new Item(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT));
            ForgeRegistries.ITEMS.register(new ResourceLocation(mod.MOD_ID,"item_bullet"), mod.item_bullet);

        }*/
        /*{
            mod.item_grenade =  new Item(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).stacksTo(8));
            ForgeRegistries.ITEMS.register(new ResourceLocation(mod.MOD_ID,"item_grenade"), mod.item_grenade);
            /*item_grenade =  new ItemGrenade(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).stacksTo(8))
                    .setRegistryName(new ResourceLocation(MOD_ID,"item_grenade"));
            event.getRegistry().register(item_grenade);*
        }
        {
            mod.item_hg =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(7));
           /* item_hg =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(7))
                    .setRegistryName(new ResourceLocation(MOD_ID,"item_hg"));*
            ItemGunBase gun = (ItemGunBase) mod.item_hg;
            if (FMLLoader.getDist().isClient())
            {
                gun.obj_true = true;
                gun.obj_model_resource = "classicguns:textures/model/model_hg.mqo";
                gun.obj_tex = "classicguns:textures/model/model_hg.png";
            }
            gun.powor = 5;
            gun.speed = 3F;
            gun.bure = 3F;
            gun.bureads = 1.0F;
            gun.recoil = 2.0F;
            gun.recoilads = 0.5F;
            gun.reloadtime = 40;
            gun.scopezoom = 1.0F;
            gun.cycle = 3;

            gun.magazine = mod.item_bullet;
            gun.fire_sound = "fire_hg";

            gun.model_y = -1.5F;
            gun.Sprintrotationx = -60F;
            gun.Sprintrotationy = 00F;
            gun.Sprintrotationz = 0F;
            gun.model_x_ads = 0.0F;
            gun.model_y_ads = -1.23F;
            gun.model_z_ads = -1.5F;
            gun.model_muzz_jump_x = -5;
            gun.model_cock_z = -0.4F;
            //event.getRegistry().register(item_hg);
            ForgeRegistries.ITEMS.register(new ResourceLocation(mod.MOD_ID,"item_hg"), mod.item_hg);
        }
        {
            mod.item_smg =  new ItemGun_AR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(21));
            ItemGunBase gun = (ItemGunBase)mod.item_smg;
            if (FMLLoader.getDist().isClient())
            {
                gun.obj_true = true;
                gun.obj_model_resource = "classicguns:textures/model/model_smg.mqo";
                gun.obj_tex = "classicguns:textures/model/model_smg.png";
            }
            gun.powor = 5;
            gun.speed = 3F;
            gun.bure = 3F;
            gun.bureads = 1.5F;
            gun.recoil = 0.5F;
            gun.recoilads = 0.3F;
            gun.reloadtime = 60;
            gun.scopezoom = 1.0F;
            gun.cycle = 3;

            gun.magazine = mod.item_bullet;
            gun.fire_sound = "fire_smg";

            gun.model_y = -1.5F;
            gun.Sprintrotationx = 20F;
            gun.Sprintrotationy = 60F;
            gun.Sprintrotationz = 0F;
            gun.model_x_ads = 0.0F;
            gun.model_y_ads = -1.125F;
            gun.model_z_ads = -3F;
            gun.model_muzz_jump_x = -5;
            gun.model_cock_z = -0.4F;
            ForgeRegistries.ITEMS.register(new ResourceLocation(mod.MOD_ID,"item_smg"), mod.item_smg);
        }
        {
            mod.item_sr =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(2));
            ItemGunBase gun = (ItemGunBase) mod.item_sr;
            if (FMLLoader.getDist().isClient())
            {
                gun.obj_true = true;
                gun.obj_model_resource = "classicguns:textures/model/model_sr.mqo";
                gun.obj_tex = "classicguns:textures/model/model_sr.png";
            }
            gun.powor = 16;
            gun.speed = 16F;
            gun.bure = 2F;
            gun.bureads = 0.1F;
            gun.recoil = 2.0F;
            gun.recoilads = 1.0F;
            gun.reloadtime = 80;
            gun.scopezoom = 4.0F;
            gun.zoomrender = false;
            gun.cycle = 3;

            gun.magazine = mod.item_bullet;
            gun.fire_sound = "fire_rifle";

            gun.model_y = -2F;
            gun.Sprintrotationx = 20F;
            gun.Sprintrotationy = 60F;
            gun.Sprintrotationz = 0F;
            gun.model_x_ads = 0.0F;
            gun.model_y_ads = -1.125F;
            gun.model_z_ads = -3F;
            gun.model_muzz_jump_x = -5;
            gun.model_cock_z = -0.4F;
            ForgeRegistries.ITEMS.register(new ResourceLocation(mod.MOD_ID,"item_sr"), mod.item_sr);
        }
        {
            mod.item_sg =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(4));
            ItemGunBase gun = (ItemGunBase) mod.item_sg;
            if (FMLLoader.getDist().isClient())
            {
                gun.obj_true = true;
                gun.obj_model_resource = "classicguns:textures/model/model_sg.mqo";
                gun.obj_tex = "classicguns:textures/model/model_sg.png";
            }
            gun.powor = 3;
            gun.speed = 2F;
            gun.bure = 8F;
            gun.bureads = 6F;
            gun.recoil = 4.0F;
            gun.recoilads = 3.0F;
            gun.reloadtime = 80;
            gun.pellet = 8;
            gun.scopezoom = 1.0F;
            gun.cycle = 3;

            gun.magazine = mod.item_bullet;
            gun.fire_sound = "fire_rifle";

            gun.model_y = -1.5F;
            gun.Sprintrotationx = 20F;
            gun.Sprintrotationy = 60F;
            gun.Sprintrotationz = 0F;
            gun.model_x_ads = 0.0F;
            gun.model_y_ads = -0.92F;
            gun.model_z_ads = -1F;
            gun.model_muzz_jump_x = -5;
            gun.model_cock_z = -0.4F;
            ForgeRegistries.ITEMS.register(new ResourceLocation(mod.MOD_ID,"item_sg"), mod.item_sg);
        }
        {
            mod.item_mg =  new ItemGun_AR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(48));
            ItemGunBase gun = (ItemGunBase) mod.item_mg;
            if (FMLLoader.getDist().isClient())
            {
                gun.obj_true = true;
                gun.obj_model_resource = "classicguns:textures/model/model_mg.mqo";
                gun.obj_tex = "classicguns:textures/model/model_mg.png";
            }
            gun.powor = 5;
            gun.speed = 3F;
            gun.bure = 4F;
            gun.bureads = 2F;
            gun.recoil = 0.2F;
            gun.recoilads = 0.1F;
            gun.reloadtime = 100;
            gun.scopezoom = 1.0F;
            gun.cycle = 3;
            gun.movespeed = 0.5F;

            gun.magazine = mod.item_bullet;
            gun.fire_sound = "fire_rifle";

            gun.model_y = -2F;
            gun.Sprintrotationx = 20F;
            gun.Sprintrotationy = 60F;
            gun.Sprintrotationz = 0F;
            gun.model_x_ads = 0.0F;
            gun.model_y_ads = -1.6F;
            gun.model_z_ads = -1.5F;
            gun.model_muzz_jump_x = -5;
            gun.model_cock_z = -0.4F;
            ForgeRegistries.ITEMS.register(new ResourceLocation(mod.MOD_ID,"item_mg"), mod.item_mg);
        }
        {
            mod.item_gl =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(2));
            ItemGunBase gun = (ItemGunBase) mod.item_gl;
            if (FMLLoader.getDist().isClient())
            {
                gun.obj_true = true;
                gun.obj_model_resource = "classicguns:textures/model/model_gl.mqo";
                gun.obj_tex = "classicguns:textures/model/model_gl.png";
            }
            gun.powor = 0;
            gun.speed = 2F;
            gun.bure = 3F;
            gun.bureads = 1.5F;
            gun.recoil = 5.0F;
            gun.recoilads = 2.5F;
            gun.reloadtime = 80;
            gun.scopezoom = 1.0F;
            gun.cycle = 3;

            gun.gra = 0.010F;
            gun.exlevel = 3.0F;
            gun.magazine = mod.item_grenade;
            gun.fire_sound = "fire_grenade";

            gun.model_y = -2F;
            gun.Sprintrotationx = 20F;
            gun.Sprintrotationy = 60F;
            gun.Sprintrotationz = 0F;
            gun.model_x_ads = 0.0F;
            gun.model_y_ads = -1.8F;
            gun.model_z_ads = 1F;
            gun.model_muzz_jump_x = -5;
            gun.model_cock_z = -0.4F;
            gun.mat22_x = 0.0F;
            gun.mat22_y = 0.6F;
            gun.mat22_z = 2.8F;
            ForgeRegistries.ITEMS.register(new ResourceLocation(mod.MOD_ID,"item_gl"), mod.item_gl);
        }
        {
            mod.item_flare =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(2));
            ItemGunBase gun = (ItemGunBase) mod.item_flare;
            if (FMLLoader.getDist().isClient())
            {
                gun.obj_true = true;
                gun.obj_model_resource = "classicguns:textures/model/model_flare.mqo";
                gun.obj_tex = "classicguns:textures/model/model_flare.png";
            }
            gun.powor = -1;
            gun.speed = 2F;
            gun.bure = 0F;
            gun.bureads = 1.0F;
            gun.recoil = 2.0F;
            gun.recoilads = 0.5F;
            gun.reloadtime = 40;
            gun.scopezoom = 1.0F;
            gun.cycle = 3;

            gun.magazine = Items.TORCH;
            gun.gra = 0.02F;
            gun.fire_sound = "fire_grenade";

            gun.model_y = -1.5F;
            gun.Sprintrotationx = -60F;
            gun.Sprintrotationy = 00F;
            gun.Sprintrotationz = 0F;
            gun.model_x_ads = 1.8F;
            gun.model_y_ads = -2F;
            gun.model_z_ads = -3.5F;
            gun.model_muzz_jump_x = -5;
            gun.model_cock_z = -0.4F;
            gun.mat22_x = 0.0F;
            gun.mat22_y = 0.7F;
            gun.mat22_z = 1.2F;
            ForgeRegistries.ITEMS.register(new ResourceLocation(mod.MOD_ID,"item_flare"), mod.item_flare);
        }*/
    }
}